> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/disk-snapshot/applysnapshot.md).

# ApplySnapshot

## 1. API Description

This API (ApplySnapshot) is used to roll back a snapshot to the disk it belongs to.

{% hint style="info" %}
**Notes**

* This interface is asynchronous. The request to roll back a snapshot returns immediately after it is sent successfully, but the operation is not completed at that point. The disk rollback status can be queried by calling the [DescribeDisks](/api-reference/zec/disk/describedisks.md) interface: if the disk status changes from `ROLLING_BACK` to `AVAILABLE` or `IN_USE`, the rollback succeeded. No operation can be performed on the disk during the rollback.
* The snapshot used for the rollback must be in the AVAILABLE status. The snapshot status can be queried through the [DescribeSnapshots](/api-reference/zec/disk-snapshot/describesnapshots.md) interface. See the description of the `SnapshotState` field in the output parameters.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                                                  |
| -------------- | -------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| snapshotId     | Yes      | String | <p>Unique ID of the snapshot.</p><p>It can be obtained by calling <a href="/api-reference/zec/disk-snapshot/describesnapshots.md">DescribeSnapshots</a>.</p> |
| diskId         | Yes      | String | <p>Disk ID.</p><p>It can be obtained by calling <a href="/api-reference/zec/disk/describedisks.md">DescribeDisks</a>.</p>                                    |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Roll back a snapshot.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ApplySnapshot
<Common Request Params>

Request：
{
    "snapshotId": "snapshotId1",
    "diskId": "disk1"
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                | Description                                                   |
| ---------------- | ----------------------------------------- | ------------------------------------------------------------- |
| 404              | INVALID\_DISK\_NOT\_FOUND                 | Disk does not exist.                                          |
| 404              | INVALID\_DISK\_SNAPSHOT\_NOT\_FOUND       | Snapshot does not exist.                                      |
| 400              | OPERATION\_DENIED\_DISK\_STATUS           | Operations on the disk with current status are not supported. |
| 400              | OPERATION\_DENIED\_DISK\_SNAPSHOT\_STATUS | The operation is not supported for current snapshot state.    |
